# php2gpc
**[Read in English](README.md)**

# Назначение

Консольная утилита которая позволяет сконвертировать специально сформированный PHP-код в GPC-скрипт используемый для программирования Cronusmax.

# Установка
```bash
composer global require inside/php2gpc
```
<sub>(+ убедитесь что у вас прописан путь к папке bin composer'а в PATH)</sub>

# Использование
```bash
php2gpc index.php script.gpc
```

# Принципы написания кода

## События
Cronusmax позволяет обрабатывать два события: init и main.
Чтобы сделать это, достаточно объявить функции с такими именами. Объявленные аргументы будут проигнорированы.

## Комбо
Для объявления комбо следует объявить переменную и присвоить ей анонимную функцию.
Для работы следует использовать соответствующие документации функции, однако имя комбо нужно передавать в качестве строки.

## Функции
Просто объявить функцию.
Вызвать можно с помощью call('funcname') либо просто вызвать, как это обычно делается в PHP.

## Объявление переменных и констант
Переменную можно объявить где угодно. При конвертации она автоматически будет объявлена в начале скрипта.
Константы задаются стандартным для PHP-способом (define, const).

# Планируется

## Генерируемые комбо
Сделать возможным объявление аргументов у комбо. Например:
```php
$sidestep = function($direction) {/* some stuff with $direction */}

combo_run('sidestep', PS4_UP);
combo_run('sidestep', PS4_DOWN);
```
&rarr;
```gpc
combo sitestep_PS4_UP {/* some stuff with PS4_UP */}
combo sitestep_PS4_DOWN {/* some stuff with PS4_DOWN */}

combo_run(sidestep_PS4_UP);
combo_run(sidestep_PS4_DOWN);
```
